<template>


  <v-layout align-center justify-center row wrap style="background-color;primary" display: flex>
                <v-dialog v-model="dialogCondition" width="420" persistent>
                <v-card class="textcard" style="height:450px;" >
                  <v-card-title class="headline green--text">
                    <!-- <v-btn icon @click="dialogCondition = false" v-if="!mobileView">
                      <v-icon>mdi-close</v-icon>
                     </v-btn> -->
                     <b style="font-family: Sarabun, sans-serif;">Terms and Conditions</b>
                  </v-card-title>
                  <v-card style="height:320px; max-width:400px; margin:0 20px 10px 20px; overflow:auto;font-family: Sarabun, sans-serif;" class="elevation-0">
                      เรียนท่านผู้ใช้บริการ INET e-Payment <br><b>กรุณาอ่านข้อตกลงด้านล่างอย่างละเอียด ก่อนทำการชำระเงินค่าสินค้าและบริการ</b><br><br>
                      1. ผู้ใช้บริการ ใช้บัตรเดบิต/บัตรเครดิต ที่ออกโดยธนาคารพานิชย์ในประเทศไทย และภายใต้ผู้ให้บริการเครือข่าย Visa, Master หรือ JCB<br>
                      2. ในการทำรายการครั้งแรก ต้องทำการยืนยันการใช้บัตร และกรอกรหัส Verified by VISA, MasterCard SecureCode หรือ J/Secure เพื่อชำระเงิน<br>
                      3. การจำหน่ายสินค้า/บริการ เป็นความรับผิดชอบของผู้จัดจำหน่ายสินค้า/บริการ แต่เพียงผู้เดียว บริษัท อินเทอร์เน็ตประเทศไทย จำกัด (มหาชน)ไม่ใช่ผู้จัดจำหน่ายสินค้า/บริการ และไม่มีส่วนรับผิดชอบใดๆเกี่ยวกับสินค้า/บริการ กรณีผู้ใช้บริการมีข้อสงสัยหรือร้องเรียนเกี่ยวกับสินค้า/บริการ
                        หรือหากต้องการใบเสร็จและใบกำกับภาษี กรุณาติดต่อโดยตรงกับบริษัทผู้จัดจำหน่ายสินค้า/บริการโดยตรง<br>
                      4. สอบถามข้อมูลเพิ่มเกี่ยวกับการชำระเงิน กรุณาติดต่อ 02-257-7188<br>
                      5. บริษัท อินเทอร์เน็ตประเทศไทย จำกัด (มหาชน) ขอสงวนสิทธิ์ในการเปลี่ยนแปลงเงื่อนไข ข้อตกลง โดยไม่ต้องแจ้งให้ทราบล่วงหน้า
                        และกรณีมีข้อพิพาท คำตัดสินของ บริษัท อินเทอร์เน็ตประเทศไทย จำกัด (มหาชน) ให้ถือเป็นที่สิ้นสุด<br>
                      6. ผู้ใช้บริการยืนยันรับทราบเงื่อนไขในการให้บริการการซื้อสินค้า/บริการครั้งนี้<br><br>
                      ในนามของบริษัท อินเทอร์เน็ตประเทศไทย จำกัด (มหาชน) <br> ขอขอบพระคุณท่านที่เลือกใช้บริการ INET e-Payment<br><br>
                  </v-card>
                  <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn
                      color="green darken-1"
                      class="white--text"
                      style="font-family: Sarabun, sans-serif;"
                      text
                      @click="checkchkbox = 'true', chkbox=true , dialogCondition = false"
                    >
                      I Agree
                    </v-btn>
                  </v-card-actions>
                </v-card>
              </v-dialog>
    <v-flex md12 pa-1 >
      <v-card class="mx-auto my-12" elevation="0" width="100%" height="100%">
        <v-progress-linear v-model="valueDeterminate"  background-color="#C1C9D2" color="#3A8300"></v-progress-linear>

        <v-stepper value="1" class="text-stepper-step">
          <v-stepper-header>
            <v-stepper-step step="" complete color="#D7B30B"  >เลือกรายการจ่ายเงิน</v-stepper-step>
            <v-stepper-step complete    color="#D5D0CF"  step="">สรุปการสั่งจ่ายเงิน</v-stepper-step>
            <v-stepper-step complete   color="#D5D0CF" step="">ชำระเงิน</v-stepper-step>
          </v-stepper-header>
        </v-stepper>
        <v-layout>
          <v-flex xs7>
            <div class="font-size-24-bold title-style">
              เลือกรายการจ่ายเงิน
            </div>
          </v-flex>
          <v-flex xs2 style="margin-top: 10px;display: flex;justify-content: flex-end;">
            <v-btn v-if="this.role === 'User'" class="btn-create" @click="openCreateDialog()">สร้างรายการจ่ายเงิน</v-btn>
          </v-flex>
          <v-flex xs3>
            <v-text-field outline style="margin: 16px 32px 0px 0px;font-family: Sarabun, sans-serif;"
                placeholder="Search"
                ref="Search"
                append-icon="search"
                v-model="billssearch">
            </v-text-field>
          </v-flex>
        </v-layout>

      <div>
          <v-flex md12 pa-1>
            <!-- table desktop -->
              <v-data-table
                v-model="selected"
                :rows-per-page-items="rowperpage"
                :pagination.sync="pagination"
                class="elevation-0 custom-table-cell table-style"
                :headers="headers"
                :items="billsview"
                :search="billssearch"
                :loading="istableloading"
                @input="onCheckboxChange"
                item-key="order_id"
                select-all
                v-if="!mobileView"
                disable-initial-sort
              >
                <template v-slot:items="props" v-bind:class="{'active-class-name': isActive(sidemenu)}">
                  <tr style="cursor: pointer;">
                    <td style="cursor: pointer;">
                      <v-checkbox color='#3A8300' v-model="props.selected" primary hide-details></v-checkbox>
                    </td>
                    <td class="text-xs-left" @click="openDialogDetail(props)">
                      {{ props.item.order_id }}
                    </td>
                    <!-- <td class="text-xs-left" style="min-width:200px;max-width: 200px;">{{ props.item.detail }}</td> -->
                    <td class="text-xs-left" @click="openDialogDetail(props)">{{ props.item.receiver_company }}</td>
                    <td class="text-xs-left" @click="openDialogDetail(props)">{{ props.item.doc_date }}</td>
                    <!-- <td class="text-xs-left">{{ props.item.receiver_tax_id }}</td>
                    <td class="text-xs-left">{{ props.item.receiver_account_no }}</td>
                    <td class="text-xs-left">{{ props.item.receiver_bankcode }}</td>
                    <td class="text-xs-left">{{ props.item.receiver_email }}</td>
                    <td class="text-xs-left">{{ props.item.income_type }}</td> -->
                    <td class="text-xs-right" style="padding: 0 40px" @click="openDialogDetail(props)">{{ props.item.amountExcVat }}</td>
                    <!-- <td class="text-xs-right" style="padding: 0 40px">{{ props.item.vatAmount }}</td>
                    <td class="text-xs-left">{{ props.item.wht_rate }} %</td>
                    <td class="text-xs-right" style="padding: 0 40px">{{ props.item.whtAmount }}</td>
                    <td class="text-xs-left">{{ props.item.payer_tax_id }}</td> -->

                  </tr>
                </template>
              </v-data-table>
              <!-- end table desktop -->
              <!-- table mobile -->
              <v-data-table
                v-model="selected"
                :rows-per-page-items="rowperpage"
                :pagination.sync="pagination"
                class="elevation-0 custom-table-cell table-style"
                :headers="headers"
                :items="billsview"
                :search="billssearch"
                :loading="istableloading"
                @input="onCheckboxChange"
                item-key="order_id"
                select-all
                v-if="mobileView"
                disable-initial-sort
              >
                <template v-slot:items="props" v-bind:class="{'active-class-name': isActive(sidemenu)}" >
                  <tr style="cursor: pointer;">
                    <td style="cursor: pointer;">
                      <v-checkbox color="#3A8300" v-model="props.selected" primary hide-details></v-checkbox>
                    </td>
                    <td class="text-xs-left" @click="openDialogDetail(props)">
                      {{ props.item.order_id }}
                    </td>
                    <!-- <td class="text-xs-left" style="min-width:200px;max-width: 200px;">{{ props.item.detail }}</td> -->
                    <td class="text-xs-left" @click="openDialogDetail(props)">{{ props.item.receiver_company }}</td>
                    <td class="text-xs-left" @click="openDialogDetail(props)">{{ props.item.doc_date }}</td>
                    <!-- <td class="text-xs-left">{{ props.item.receiver_tax_id }}</td>
                    <td class="text-xs-left">{{ props.item.receiver_account_no }}</td>
                    <td class="text-xs-left">{{ props.item.receiver_bankcode }}</td>
                    <td class="text-xs-left">{{ props.item.receiver_email }}</td>
                    <td class="text-xs-left">{{ props.item.income_type }}</td> -->
                    <td class="text-xs-right" style="padding: 0 40px" @click="openDialogDetail(props)">{{ props.item.amountExcVat }}</td>
                    <!-- <td class="text-xs-right" style="padding: 0 40px">{{ props.item.vatAmount }}</td>
                    <td class="text-xs-left">{{ props.item.wht_rate }} %</td>
                    <td class="text-xs-right" style="padding: 0 40px">{{ props.item.whtAmount }}</td>
                    <td class="text-xs-left">{{ props.item.payer_tax_id }}</td> -->

                  </tr>
                </template>
              </v-data-table>
              <!-- end table mobile -->
          </v-flex>
        <!-- </v-card> -->
      </div>
      </v-card>
      <div>
        <br>
        <v-flex xs12  v-if="role !== 'Admin'">
          <v-layout align-end justify-end min-width="auto" v-if="!mobileView">
            <v-flex xs1 offset-xs8 min-width="auto">
                  <div class="item" align="left">เลือกแล้ว : </div>
                  <div class="item" align="left">ยอดรวม (บาท) :</div>
            </v-flex>
            <v-flex xs1 min-width="auto">
                <div class="summary" align="left" > {{this.selected.length}} รายการ</div>
                <div class="summary" align="left" > <strong>{{ totalprice }}</strong></div>
            </v-flex>
            <v-flex xs2 v-if="!mobileView && this.selected.length ===0">
              <v-btn v-if="!mobileView" style="width:100%;font-family: Sarabun, sans-serif;font-weight:bold"
              color="#C7C7C7" class="white--text"  @click="opentotalpaymodal(selected, totalprice, subtotalprice, vatamount ,totalwht ,invoiceaccountID)">Confirm</v-btn>
            </v-flex>
            <v-flex xs2 v-if="!mobileView && this.selected.length !==0 ">
              <v-btn v-if="!mobileView" style="width:100%;font-family: Sarabun, sans-serif;font-weight:bold"
              color="#3A8300" class="white--text"  @click="opentotalpaymodal(selected, totalprice, subtotalprice, vatamount ,totalwht ,invoiceaccountID)">Confirm</v-btn>
            </v-flex>
          </v-layout>
          <v-layout v-if="mobileView">
            <v-flex xs2  offset-xs6 min-width="auto">
                  <div class="item" align="left">เลือกแล้ว : </div>
                  <div class="item" align="left">ยอดรวม (บาท) :</div>
            </v-flex>
            <v-flex xs1 min-width="auto">
                <div class="summary" align="left" > {{this.selected.length}} รายการ</div>
                <div class="summary" align="left" > <strong>{{ totalprice }}</strong></div>
            </v-flex>
            <!-- <div v-if="!scrennView"><br></div> -->
            <v-flex xs4 px-3 v-if="this.selected.length ===0">
              <v-btn color="#C7C7C7" class="white--text" style="font-family: Sarabun, sans-serif;font-weight:bold" @click="opentotalpaymodal(selected, totalprice, subtotalprice, vatamount ,totalwht ,invoiceaccountID)">Confirm</v-btn>
            </v-flex>
            <!-- {{bills.length}} -->
            <!-- s it Idle? - {{ isIdle }} -->


            <!-- <div v-if="!scrennView"><br></div> -->
            <v-flex xs4 px-3 v-if="this.selected.length !==0">
              <v-btn color="#3A8300" class="white--text" style="font-family: Sarabun, sans-serif;font-weight:bold" @click="opentotalpaymodal(selected, totalprice, subtotalprice, vatamount ,totalwht ,invoiceaccountID)">Confirm</v-btn>
            </v-flex>
            <!-- {{bills.length}} -->
            <!-- s it Idle? - {{ isIdle }} -->
            </v-layout>
        </v-flex>
      </div>
    </v-flex>

    <!-- --------------------- Detail Dialog -------------------------- -->
    <v-dialog v-model="detail_dialog" fullscreen hide-overlay>
      <v-card>
        <v-form v-model="isFormValid">
          <v-card-title>
            <span class="title">Document Number: {{ d_docno }}</span>
            <v-spacer></v-spacer>
            <v-btn icon @click="closeDetailDialog()">
              <v-icon>mdi-close</v-icon>
            </v-btn>
          </v-card-title>
          <v-card-text>
            <v-container style="margin-top: -30px">
              <v-layout class="text-dialog">
                <v-flex xs3>
                <span class="text-head">Document Number <span class="red--text">*</span></span>
                </v-flex>
                <v-flex xs3>
                  <v-text-field
                  outline
                  name="d_docno"
                  v-model="d_docno"
                  :disabled="this.role !== 'User'"
                  :rules="[
                    () =>
                      !!d_docno || 'This field is required'
                    ]">
                  </v-text-field>
                </v-flex>
                <v-flex xs3 style="padding-left:12px">
                  <span class="text-head">Document Date <span class="red--text">*</span></span>
                </v-flex>
                <v-flex xs3>
                  <v-menu
                  v-model="menu_detail"
                  :close-on-content-click="false"
                  :nudge-left="100"
                  transition="scale-transition"
                  offset-y
                  min-width="auto"
                  :disabled="this.role !== 'User'"
                >
                  <template v-slot:activator="{ on, attrs }">
                    <v-text-field
                      outline
                      :value="computedDateFormattedMomentjs"
                      v-model="d_docdate"
                      append-icon="mdi-calendar"
                      readonly
                      v-bind="attrs"
                      v-on="on"
                      :rules="[
                    () =>
                      !!d_docdate || 'This field is required'
                    ]"
                    ></v-text-field>
                  </template>
                  <v-date-picker
                    no-title
                    color="green lighten-1"
                    v-model="d_docdate"
                    @input="menu_detail = false"
                  ></v-date-picker>
                </v-menu>
                </v-flex>
              </v-layout>

              <v-layout class="text-dialog">
                <v-flex xs3>
                  <span class="text-head">Receiver Company <span class="red--text">*</span></span>
                </v-flex>
                <v-flex xs3>
                  <v-text-field
                    outline
                    name="d_receiver_company"
                    v-model="d_receiver_company"
                    :disabled="this.role !== 'User'"
                    :rules="[
                    () =>
                      !!d_receiver_company || 'This field is required'
                    ]">
                  </v-text-field>
                </v-flex>
                <v-flex xs3 style="padding-left:12px">
                  <span class="text-head">Receiver Tax ID <span class="red--text">*</span></span>
                </v-flex>
                <v-flex xs3>
                  <v-text-field
                    outline
                    name="d_receiver_tax_id"
                    v-model="d_receiver_tax_id"
                    :disabled="this.role !== 'User'"
                    :rules="[
                    () =>
                      !!d_receiver_tax_id || 'This field is required'
                    ]">
                     <!-- () =>
                      /^\d+$/.test(d_receiver_tax_id) ||'Receiver Tax ID must be number' -->
                  </v-text-field>
                </v-flex>
              </v-layout>

              <v-layout class="text-dialog" >
                <v-flex xs3>
                  <span class="text-head">Receiver Account Name <span class="red--text">*</span></span>
                </v-flex>
                <v-flex xs3>
                  <v-text-field
                    outline
                    name="d_receiver_account_name"
                    v-model="d_receiver_account_name"
                    :disabled="this.role !== 'User'"
                    :rules="[
                    () =>
                      !!d_receiver_account_name || 'This field is required'
                    ]">
                  </v-text-field>
                </v-flex>
                <v-flex xs3 style="padding-left:12px">
                  <span class="text-head">Receiver Account No <span class="red--text">*</span></span>
                </v-flex>
                <v-flex xs3>
                  <v-text-field
                    outline
                    name="d_receiver_account_no"
                    v-model="d_receiver_account_no"
                    :disabled="this.role !== 'User'"
                    :rules="[
                    () =>
                      !!d_receiver_account_no || 'This field is required',
                    () =>
                      /^\d+$/.test(d_receiver_account_no) ||'Receiver Account No must be number'
                    ]">
                  </v-text-field>
                </v-flex>
              </v-layout>

              <v-layout class="text-dialog">
                <v-flex xs3>
                  <span class="text-head">Receiver Email <span class="red--text">*</span></span>
                </v-flex>
                <v-flex xs3>
                  <v-text-field
                    outline
                    name="d_receiver_email"
                    v-model="d_receiver_email"
                    :disabled="this.role !== 'User'"
                    :rules="[
                    () =>
                      !!d_receiver_email || 'This field is required',
                    () => /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(this.d_receiver_email)
                    ||'Receiver Email is not formatted'
                    ]">
                  </v-text-field>
                </v-flex>
              </v-layout>

              <v-layout class="text-dialog" >
                <v-flex xs3>
                  <span class="text-head">Amount <span class="red--text">*</span></span>
                </v-flex>
                <v-flex xs3>
                  <v-text-field
                    outline
                    name="d_amount_exc_vat"
                    v-model="d_amount_exc_vat"
                    :disabled="this.role !== 'User'"
                    :rules="[
                    () =>
                      !!d_amount_exc_vat || 'This field is required',
                    () =>
                      /^\d+$/.test(d_amount_exc_vat) ||'Amount must be number'
                    ]">
                  </v-text-field>
                </v-flex>
                <v-flex xs3 style="padding-left:12px">
                <span class="text-head">VAT <span class="red--text">*</span></span>
              </v-flex>
              <v-flex xs3>
                <v-text-field
                    outline
                    name="d_vat_amount"
                    v-model="d_vat_amount"
                    :disabled="this.role !== 'User'"
                    :rules="[
                    () =>
                      !!d_vat_amount || 'This field is required',
                    () =>
                      /^\d+$/.test(d_vat_amount) ||'VAT must be number'
                    ]">
                </v-text-field>
              </v-flex>
            </v-layout>

            <v-layout class="text-dialog">
              <v-flex xs3>
                <span class="text-head">WHT <span class="red--text">*</span></span>
              </v-flex>
              <v-flex xs3>
                <v-text-field
                    outline
                    name="d_wht_amount"
                    v-model="d_wht_amount"
                    :disabled="this.role !== 'User'"
                    :rules="[
                    () =>
                      !!d_wht_amount || 'This field is required',
                    () =>
                      /^\d+$/.test(d_wht_amount) ||'WHT must be number'
                    ]">
                </v-text-field>
              </v-flex>
              <v-flex xs3 style="padding-left:12px">
                <span class="text-head">WHT Rate (%) <span class="red--text">*</span></span>
              </v-flex>
              <v-flex xs3>
                <v-text-field
                    outline
                    name="d_wht_rate"
                    v-model="d_wht_rate"
                    :disabled="this.role !== 'User'"
                    :rules="[
                    () =>
                      !!d_wht_rate || 'This field is required',
                    () =>
                      /^\d+$/.test(d_wht_rate) ||'WHT Rate must be number'
                    ]">
                </v-text-field>
              </v-flex>
            </v-layout>

            <v-layout class="text-dialog">
              <v-flex xs3>
                <span class="text-head">Pay Amount <span class="red--text">*</span></span>
              </v-flex>
              <v-flex xs3>
                <v-text-field
                    outline
                    name="d_pay_amount"
                    v-model="d_pay_amount"
                    :disabled="this.role !== 'User'"
                    :rules="[
                    () =>
                      !!d_pay_amount || 'This field is required'
                    ]">
                </v-text-field>
              </v-flex>
            </v-layout>

            <v-layout class="text-dialog" >
              <v-flex xs3>
                <span class="text-head">Type of Income <span class="red--text">*</span></span>
              </v-flex>
              <v-flex >
                <v-select
                  outline
                  :items="income_types"
                  name="d_income_type"
                  v-model="d_income_type"
                  :disabled="this.role !== 'User'"
                  :rules="[
                    () =>
                      !!d_income_type || 'This field is required'
                    ]">
                </v-select>

              </v-flex>
            </v-layout>

            <v-layout class="text-dialog" >
              <v-flex xs3>
                <span class="text-head">Detail <span class="red--text">*</span></span>
              </v-flex>
              <v-flex>
                <v-text-field
                  outline
                  name="d_detail"
                  v-model="d_detail"
                  :disabled="this.role !== 'User'"
                  :rules="[
                    () =>
                      !!d_detail || 'This field is required'
                    ]">
                </v-text-field>
              </v-flex>
            </v-layout>
            </v-container>
          </v-card-text>

          <v-card-actions v-if="this.role === 'User'">
            <v-spacer></v-spacer>
            <v-btn
              outline
              class="btn-close"
              text
              @click="closeDetailDialog()"
            >
              Close
            </v-btn>
            <v-btn
              class="btn-save"
              text
              @click="onSave()"
              :disabled="!isFormValid"
            >
              Save
            </v-btn>
          </v-card-actions>
        </v-form>
      </v-card>
    </v-dialog>
    <!-- --------------------- End Detail Dialog -------------------------- -->

    <!-- --------------------- Create Dialog -------------------------- -->
    <v-dialog v-model="create_dialog" fullscreen hide-overlay>
      <v-card>
        <v-form v-model="isFormValid">
          <v-card-title>
            <span class="title">สร้างรายการจ่ายเงิน</span>
            <v-spacer></v-spacer>
            <v-btn icon @click="closeCreateDialog()">
              <v-icon>mdi-close</v-icon>
            </v-btn>
          </v-card-title>
          <v-card-text>
            <v-container style="margin-top: -30px">
              <v-layout class="text-dialog">
                <v-flex xs3>
                <span class="text-head">Document Number <span class="red--text">*</span></span>
                </v-flex>
                <v-flex xs3>
                  <v-text-field
                  outline
                  name="c_docno"
                  v-model="c_docno"
                  :rules="[
                    () =>
                      !!c_docno || 'This field is required'
                    ]">
                  </v-text-field>
                </v-flex>
                <v-flex xs3 style="padding-left:12px">
                  <span class="text-head">Document Date <span class="red--text">*</span></span>
                </v-flex>
                <v-flex xs3>
                  <v-menu
                  v-model="menu_create"
                  :close-on-content-click="false"
                  :nudge-left="100"
                  transition="scale-transition"
                  offset-y
                  min-width="auto"
                >
                  <template v-slot:activator="{ on, attrs }">
                    <v-text-field
                      outline
                      :value="computedDateFormattedMomentjs2"
                      v-model="c_docdate"
                      append-icon="mdi-calendar"
                      readonly
                      v-bind="attrs"
                      v-on="on"
                      :rules="[
                    () =>
                      !!c_docdate || 'This field is required'
                    ]"
                    ></v-text-field>
                  </template>
                  <v-date-picker
                    no-title
                    color="green lighten-1"
                    v-model="c_docdate"
                    @input="menu_create = false"
                  ></v-date-picker>
                </v-menu>
                </v-flex>
              </v-layout>

              <v-layout class="text-dialog">
                <v-flex xs3>
                  <span class="text-head">Receiver Company <span class="red--text">*</span></span>
                </v-flex>
                <v-flex xs3>
                  <v-text-field
                    outline
                    name="c_receiver_company"
                    v-model="c_receiver_company"
                    :rules="[
                    () =>
                      !!c_receiver_company || 'This field is required'
                    ]">
                  </v-text-field>
                </v-flex>
                <v-flex xs3 style="padding-left:12px">
                  <span class="text-head">Receiver Tax ID <span class="red--text">*</span></span>
                </v-flex>
                <v-flex xs3>
                  <v-text-field
                    outline
                    name="c_receiver_tax_id"
                    v-model="c_receiver_tax_id"
                    :rules="[
                    () =>
                      !!c_receiver_tax_id || 'This field is required'
                    ]">
                    <!-- () =>
                      /^\d+$/.test(d_receiver_tax_id) ||'Receiver Tax ID must be number' -->
                  </v-text-field>
                </v-flex>
              </v-layout>

              <v-layout class="text-dialog" >
                <v-flex xs3>
                  <span class="text-head">Receiver Account Name <span class="red--text">*</span></span>
                </v-flex>
                <v-flex xs3>
                  <v-text-field
                    outline
                    name="c_receiver_account_name"
                    v-model="c_receiver_account_name"
                    :rules="[
                    () =>
                      !!c_receiver_account_name || 'This field is required'
                    ]">
                  </v-text-field>
                </v-flex>
                <v-flex xs3 style="padding-left:12px">
                  <span class="text-head">Receiver Account No <span class="red--text">*</span></span>
                </v-flex>
                <v-flex xs3>
                  <v-text-field
                    outline
                    name="c_receiver_account_no"
                    v-model="c_receiver_account_no"
                    :rules="[
                    () =>
                      !!c_receiver_account_no || 'This field is required',
                    () =>
                      /^\d+$/.test(c_receiver_account_no) ||'Receiver Account No must be number'
                    ]">
                  </v-text-field>
                </v-flex>
              </v-layout>

              <v-layout class="text-dialog">
                <v-flex xs3>
                  <span class="text-head">Receiver Bank Code <span class="red--text">*</span></span>
                </v-flex>
                <v-flex xs3>
                  <v-select
                  outline
                  :items="banks"
                  name="c_receiver_bank_code"
                  v-model="c_receiver_bank_code"
                  :rules="[
                    () =>
                      !!c_receiver_bank_code || 'This field is required'
                    ]">
                  </v-select>
                </v-flex>
                <v-flex xs3 style="padding-left:12px">
                  <span class="text-head">Receiver Type <span class="red--text">*</span></span>
                </v-flex>
                <v-flex xs3 >
                  <v-select
                  outline
                  :items="receiver_type"
                  name="c_receiver_type"
                  v-model="c_receiver_type"
                  :rules="[
                    () =>
                      !!c_receiver_type || 'This field is required'
                    ]">
                  </v-select>
                </v-flex>
              </v-layout>

              <v-layout class="text-dialog">
                <v-flex xs3>
                  <span class="text-head">Receiver Mobile <span class="red--text">*</span></span>
                </v-flex>
                <v-flex xs3 >
                  <v-text-field
                    outline
                    name="c_receiver_mobile"
                    v-model="c_receiver_mobile"
                    :rules="[
                    () =>
                      !!c_receiver_mobile || 'This field is required'
                    ]">
                  </v-text-field>
                </v-flex>
                <v-flex xs3  style="padding-left:12px">
                  <span class="text-head">Receiver Email <span class="red--text">*</span></span>
                </v-flex>
                <v-flex xs3 >
                  <v-text-field
                    outline
                    name="c_receiver_email"
                    v-model="c_receiver_email"
                    :rules="[
                    () =>
                      !!c_receiver_email || 'This field is required',
                    () => /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(this.c_receiver_email)
                    ||'Receiver Email is not formatted'
                    ]">
                  </v-text-field>
                </v-flex>
              </v-layout>

              <v-layout class="text-dialog" >
                <v-flex xs3>
                  <span class="text-head">Amount <span class="red--text">*</span></span>
                </v-flex>
                <v-flex xs3>
                  <v-text-field
                    outline
                    name="c_amount_exc_vat"
                    v-model="c_amount_exc_vat"
                    :rules="[
                    () =>
                      !!c_amount_exc_vat || 'This field is required',
                    () =>
                      /^\d+$/.test(c_amount_exc_vat) ||'Amount must be number'
                    ]">
                  </v-text-field>
                </v-flex>
                <v-flex xs3 style="padding-left:12px">
                <span class="text-head">VAT <span class="red--text">*</span></span>
              </v-flex>
              <v-flex xs3>
                <v-text-field
                    outline
                    name="c_vat_amount"
                    v-model="c_vat_amount"
                    :rules="[
                    () =>
                      !!c_vat_amount || 'This field is required',
                    () =>
                      /^\d+$/.test(c_vat_amount) ||'VAT must be number'
                    ]">
                </v-text-field>
              </v-flex>
            </v-layout>

            <v-layout class="text-dialog">
              <v-flex xs3>
                <span class="text-head">WHT <span class="red--text">*</span></span>
              </v-flex>
              <v-flex xs3>
                <v-text-field
                    outline
                    name="c_wht_amount"
                    v-model="c_wht_amount"
                    :rules="[
                    () =>
                      !!c_wht_amount || 'This field is required',
                    () =>
                      /^\d+$/.test(c_wht_amount) ||'WHT must be number'
                    ]">
                </v-text-field>
              </v-flex>
              <v-flex xs3 style="padding-left:12px">
                <span class="text-head">WHT Rate (%) <span class="red--text">*</span></span>
              </v-flex>
              <v-flex xs3>
                <v-text-field
                    outline
                    name="c_wht_rate"
                    v-model="c_wht_rate"
                    :rules="[
                    () =>
                      !!c_wht_rate || 'This field is required',
                     () =>
                      /^\d+$/.test(c_wht_rate) ||'WHT Rate must be number'
                    ]">
                </v-text-field>
              </v-flex>
            </v-layout>

            <v-layout class="text-dialog">
              <v-flex xs3 >
                <span class="text-head">Wht Condition <span class="red--text">*</span></span>
              </v-flex>
              <v-flex xs3>
                <v-select
                  outline
                  :items="wht_cons"
                  name="c_wht_condition"
                  v-model="c_wht_condition"
                  :rules="[
                    () =>
                      !!c_wht_condition ||
                      'This field is required'
                      ]"
                ></v-select>

              </v-flex>
            </v-layout>

            <v-layout class="text-dialog" >
              <v-flex xs3>
                <span class="text-head">Type of Income <span class="red--text">*</span></span>
              </v-flex>
              <v-flex >
                <v-select
                  outline
                  :items="income_types"
                  name="c_income_type"
                  v-model="c_income_type"
                  :rules="[
                    () =>
                      !!c_income_type || 'This field is required'
                    ]">
                </v-select>
              </v-flex>
            </v-layout>

            <v-layout class="text-dialog" >
              <v-flex xs3>
                <span class="text-head">Detail <span class="red--text">*</span></span>
              </v-flex>
              <v-flex>
                <v-text-field
                  outline
                  name="c_detail"
                  v-model="c_detail"
                  :rules="[
                    () =>
                      !!c_detail || 'This field is required'
                    ]">
                </v-text-field>
              </v-flex>
            </v-layout>
            </v-container>
          </v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn
              outline
              class="btn-close"
              text
              @click="closeCreateDialog()"
            >
              Close
            </v-btn>
            <v-btn
              class="btn-save"
              text
              @click="onCreate()"
              :disabled="!isFormValid"
            >
              Save
            </v-btn>
          </v-card-actions>
        </v-form>
      </v-card>
    </v-dialog>
    <!-- --------------------- End Create Dialog -------------------------- -->


    <!-- <Invoicemodal /> -->
  </v-layout>
</template>

<script>
import { sync } from 'vuex-pathify'
import Invoicemodal from '@/components/Invoicemodal'
import moment from "moment"
moment.locale('en')
import Swal from "sweetalert2";

export default {
  components: {
    Invoicemodal,
  },
  data () {
    return {
      role: '',
      custName: this.$cookies.get('custName'),
      checkchkbox : this.$cookies.get('checkchkbox'),
      a: this.$session.get('selectedData'),
      b: this.$session.get('selectedPrice'),
      tout: '',
      checkStatus: true,
      drawer: null,
      istableloading: false,
      invoiceaccountID: '',
      billssearch: '',
      totalprice: '0.00',
      subtotalprice: '0.00',
      vatamount: '0.00',
      totalwht:'0.00',
      selected: [],
      items: [],
      dialogCondition: false,
      valueDeterminate: 33.3,
      headers: [
        { text: 'Doc No.', value: 'order_id', align: 'left' },
        { text: 'Receiver Company', value: 'receiver_company', align: 'left' },
        { text: 'Doc Date', value: 'doc_date', align: 'left' },
        { text: 'Amount', value: 'amount_inc_vat', align: 'center' },
        // { text: 'Detail', value: 'detail', align: 'left' },
        // { text: 'Receiver Tax ID    ', value: 'receiver_tax_id', align: 'left' },
        // { text: 'Receiver Account No', value: 'receiver_account_no', align: 'left' },
        // { text: 'Receiver Bank Code', value: 'receiver_bankcode', align: 'left' },
        // { text: 'Receiver Email', value: 'receiver_email', align: 'left' },
        // { text: 'Income Type', value: 'income_type', align: 'left' },
        // { text: 'VAT', value: 'vat_amount', align: 'left' },
        // { text: 'WHT Rate (%)', value: 'wht_rate', align: 'left' },
        // { text: 'WHT', value: 'wht_amount', align: 'left' },
        // { text: 'Sender TAX ID', value: 'sender_tax_id', align: 'left' },
      ],
      bills: [],
      data_income: [],
      rowperpage: [
        5,
        10,
        25,
        { text: '$vuetify.dataIterator.rowsPerPageAll', value: -1 }
      ],
      pagination: {
        rowsPerPage: 10
      },
      images: {
        choosefile: require("../assets/choosefile.png")
      },
      detail_dialog: false,
      isFormValid: false,
      income_types: [],

      // dialog detail
      d_id:"",
      d_docno:"",
      d_docdate:"",
      d_receiver_company:"",
      d_receiver_tax_id:"",
      d_receiver_account_name:"",
      d_receiver_account_no:"",
      d_receiver_email:"",
      d_amount_exc_vat:0.0,
      d_vat_amount:0.0,
      d_wht_amount:0.0,
      d_wht_rate:0.0,
      d_pay_amount:"",
      d_income_type:"",
      d_detail:"",


      // create dialog
      create_dialog:"",
      receiver_type:['personal', 'company'],
      banks:[],
      wht_cons: ["A", "O", "R"],
      c_docno:"",
      c_docdate:"",
      c_receiver_company:"",
      c_receiver_tax_id:"",
      c_receiver_account_name:"",
      c_receiver_account_no:"",
      c_receiver_bank_code:"",
      c_receiver_type:"",
      c_receiver_mobile:"",
      c_receiver_email:"",
      c_amount_exc_vat:0.0,
      c_vat_amount:0.0,
      c_wht_amount:0.0,
      c_wht_rate:0.0,
      c_wht_condition:"",
      c_income_type:"",
      c_detail:"",
      menu_detail:"",
      menu_create:""
    }
  },

  methods: {
    opentotalpaymodal (totalpay, price, subtotalprice, vat ,wht ,acc_id) {
      if (this.checkStatus === false){
      }
      else{
        if (totalpay.length === 0) {
        alert('Please select an invoice.')
        } else {

          this.totalpricepay = price
          this.totalExcVat = subtotalprice
          this.totalvatamount = vat // vat amount
          this.currenttotalpay = totalpay
          this.totalwht = wht
          this.invoiceaccountID = acc_id
          localStorage.setItem('currenttotalpay', JSON.stringify(this.currenttotalpay))
          this.$cookies.set('totalpricepay', this.totalpricepay)
          this.$cookies.set('totalExcVat', this.totalExcVat)
          this.$cookies.set('totalvatamount', this.totalvatamount)
          this.$cookies.set('totalwht',this.totalwht)
          this.$cookies.set('invoiceaccountID', this.invoiceaccountID)
          this.$router.push('/summarybills')
        }
      }
    },
    openinvoicemodal (invoiceno) {
      this.currentinvoiceno = invoiceno
      this.invoicemodal = true
    },
    async getmybill () {
      try {
        this.istableloading = true
        var { data } = await this.axios.get(`${process.env.VUE_APP_APIHOST}/transactions`, {
          headers: {
            Authorization: this.$cookies.get('token'),
          }
        })

        // console.log(data)
        if (data){
          this.bills = data.alltransaction
          this.data_income = data.income_type
          this.data_bankname = data.name_bank

          for (let it of this.data_income) {
            this.income_types.push(it.income_type);
          }

          for (let bn of this.data_bankname) {
            this.banks.push(bn.name);
          }
        }
        this.istableloading = false

      } catch (error) {
        this.istableloading = false
        console.log(error.message)
      }
    },
    sessionTimeout () {
      if (this.isIdle === true) {
        this.$router.push('/')
      }
    },
    addCommas (nStr) {
      nStr += ''
      var x = nStr.split('.')
      var x1 = x[0]
      var x2 = x.length > 1 ? '.' + x[1] : ''
      var rgx = /(\d+)(\d{3})/
      while (rgx.test(x1)) {
        x1 = x1.replace(rgx, '$1' + ',' + '$2')
      }
      return x1 + x2
    },
    onCheckboxChange () {
      if (this.selected.length != 0) {
        this.invoiceaccountID = this.selected[0].x
        this.totalprice = this.addCommas(
          this.selected
            .reduce(function (p, n) {
              return (
                p +parseFloat(n.amount_inc_vat)
                // p +parseFloat(n.amount_inc_vat)-parseFloat(n.wht_amount)
                // parseFloat(n.Grand_total.replace(/,/g, '').replace(' THB', ''))
              )
            }, 0)
            .toFixed(2)
        )
        this.subtotalprice = this.addCommas(
          this.selected
            .reduce(function (a, b) {
              return (
                a +
                parseFloat(b.amount_inc_vat-b.vat_amount)
              )
            }, 0)
            .toFixed(2)
        )
        this.vatamount = this.addCommas(
          this.selected
            .reduce(function (a, b) {
              return (
                a +
                parseFloat(b.vat_amount)
              )
            }, 0)
            .toFixed(2)
        )
        this.totalwht = this.addCommas(
            this.selected
              .reduce(function (g, d) {
                return (
                  g +
                  parseFloat(d.wht_amount)
                )
              }, 0)
              .toFixed(2)
          )
      } else {
        this.totalprice = '0.00',
        this.subtotalprice = '0.00',
        this.vatamount = '0.00',
        this.totalwht = '0.00',
        this.selected = []
      }
    },
    handleView () {
      this.mobileView = window.innerWidth <= 990
    },
    openDialogDetail(props) {
      this.detail_dialog = true;
      this.d_id = props.item.id
      this.d_docno = props.item.order_id;
      this.d_docdate = props.item.doc_date;
      this.d_receiver_company= props.item.receiver_company;
      this.d_receiver_tax_id= props.item.receiver_tax_id;
      this.d_receiver_account_name= props.item.receiver_account_name;
      this.d_receiver_account_no= props.item.receiver_account_no;
      this.d_receiver_email= props.item.receiver_email;
      this.d_amount_exc_vat= props.item.amount_exc_vat;
      this.d_vat_amount= props.item.vat_amount;
      this.d_wht_amount= props.item.wht_amount;
      this.d_wht_rate= props.item.wht_rate;
      this.d_pay_amount= props.item.pay_amount;
      this.d_income_type= props.item.income_type;
      this.d_detail= props.item.detail;
    },
    async onSave(){
      let data_update = {
        id:this.d_id,
        document_number:this.d_docno,
        document_date: moment(this.d_docdate).format('YYYYMMDD'),
        receiver_company:this.d_receiver_company,
        receiver_tax_id:this.d_receiver_tax_id,
        receiver_account_name:this.d_receiver_account_name,
        receiver_account_no:this.d_receiver_account_no,
        receiver_email:this.d_receiver_email,
        amount:this.d_amount_exc_vat,
        vat:this.d_vat_amount,
        wht:this.d_wht_amount,
        wht_rate:this.d_wht_rate,
        detail:this.d_detail,
        type_of_income:this.d_income_type,
        createdBy:this.$cookies.get("createdBy"),
      }

      try {
        this.istableloading = true
        var { data } = await this.axios.post(`${process.env.VUE_APP_APIHOST}/update_transaction`,
        {
          data: data_update
        },
        {
          headers: {
            Authorization: this.$cookies.get('token'),
          }
        })

        // console.log(data)
        if (data == "success") {
          Swal.fire({
            title: "Completed",
            text: "",
            icon: "success",
            showConfirmButton: false,
            timer: 1500
          });
          setTimeout(() => {
            this.istableloading = false;
            this.closeDetailDialog()
            this.getmybill ()
          }, 1800);
        } else {
          Swal.fire({
            title: data,
            text: "",
            icon: "error"
          });
          this.istableloading = false;
          // this.detail_dialog = false;
        }

      } catch (error) {
        this.istableloading = false
        console.log(error.message)
      }
    },
    closeDetailDialog(){
      this.detail_dialog = false;
      this.d_id= "";
      this.d_docno = "";
      this.d_docdate = "";
      this.d_receiver_company= "";
      this.d_receiver_tax_id= "";
      this.d_receiver_account_name= "";
      this.d_receiver_account_no= "";
      this.d_receiver_email= "";
      this.d_amount_exc_vat=0.0;
      this.d_vat_amount=0.0;
      this.d_wht_amount=0.0;
      this.d_wht_rate=0.0;
      this.d_pay_amount= "";
      this.d_income_type= "";
      this.d_detail= "";
    },
    openCreateDialog(){
      this.create_dialog = true;
      this.c_docno= "";
      this.c_docdate= "";
      this.c_receiver_company= "";
      this.c_receiver_tax_id= "";
      this.c_receiver_account_name= "";
      this.c_receiver_account_no= "";
      this.c_receiver_bank_code= [];
      this.c_receiver_type= [];
      this.c_receiver_mobile= "";
      this.c_receiver_email= "";
      this.c_amount_exc_vat=0.0;
      this.c_vat_amount=0.0;
      this.c_wht_amount=0.0;
      this.c_wht_rate=0.0;
      this.c_wht_condition= [];
      this.c_income_type= [];
      this.c_detail= "";
    },
    async onCreate(){
      let data_create = {
        document_number:this.c_docno,
        document_date: moment(this.c_docdate).format('YYYYMMDD'),
        detail:this.c_detail,
        receiver_company:this.c_receiver_company,
        receiver_tax_id:this.c_receiver_tax_id,
        receiver_account_name:this.c_receiver_account_name,
        receiver_account_no:this.c_receiver_account_no,
        receiver_bank_code:this.c_receiver_bank_code,
        receiver_type:this.c_receiver_type,
        receiver_mobile:this.c_receiver_mobile,
        receiver_email:this.c_receiver_email,
        amount:this.c_amount_exc_vat,
        vat:this.c_vat_amount,
        type_of_income:this.c_income_type,
        wht_rate:this.c_wht_rate,
        wht:this.c_wht_amount,
        wht_condition:this.c_wht_condition,
        createdBy:this.$cookies.get("createdBy"),
      }
console.log(data_create)
      try {
        this.istableloading = true
        var { data } = await this.axios.post(`${process.env.VUE_APP_APIHOST}/create_transaction`,
        {
          data: data_create
        },
        {
          headers: {
            Authorization: this.$cookies.get('token'),
          }
        })

        // console.log(data)
        if (data == "success") {
          Swal.fire({
            title: "Completed",
            text: "",
            icon: "success",
            showConfirmButton: false,
            timer: 1500
          });
          setTimeout(() => {
            this.istableloading = false;
            this.create_dialog = false;
            this.getmybill ()
          }, 1800);
        } else {
          Swal.fire({
            title: data,
            text: "",
            icon: "error"
          });
          this.istableloading = false;
        }
      } catch (error) {
        this.istableloading = false
        console.log(error.message)
      }
    },
    closeCreateDialog(){
      this.create_dialog = false;
      this.c_docno="";
      this.c_docdate="";
      this.c_receiver_company="";
      this.c_receiver_tax_id="";
      this.c_receiver_account_name="";
      this.c_receiver_account_no="";
      this.c_receiver_bank_code=[];
      this.c_receiver_type=[];
      this.c_receiver_mobile="",
      this.c_receiver_email="";
      this.c_amount_exc_vat=0.0;
      this.c_vat_amount=0.0;
      this.c_wht_amount=0.0;
      this.c_wht_rate=0.0;
      this.c_wht_condition =[];
      this.c_income_type=[];
      this.c_detail="";
    }
  },
  computed: {
    billsview () {
      return this.bills.map(bill => {
        return {
          ...bill,
          wht_rate: this.addCommas((bill.wht_rate)),
          doc_date: moment(bill.doc_date).format('YYYY-MM-DD'),
          amountExcVat:this.addCommas((bill.amount_inc_vat).toFixed(2)),
          vatAmount: this.addCommas((bill.vat_amount).toFixed(2)),
          whtAmount: this.addCommas((bill.wht_amount).toFixed(2))
        }
      })
    },
    invoicemodal: sync('invoicemodal'),
    currentinvoiceno: sync('currentinvoiceno'),
    tokenHashTaxid: sync('tokenHashTaxid'),
    computedDateFormattedMomentjs() {
      return this.d_docdate ? moment(this.d_docdate).format("YYYY-MM-DD") : "";
    },
    computedDateFormattedMomentjs2() {
      return this.c_docdate ? moment(this.c_docdate).format("YYYY-MM-DD") : "";
    }
  },
  watch: {
    tokenHashTaxid(data) {
      // console.log('unpaid tokenHashTaxid: ', data)
      this.getmybill()
    },
    chkbox (value) {
      // console.log('watch chkbox: ', value);
      if (value === false){
        this.chkbox = false
        this.checkchkbox = false
      }
    },
    checkchkbox (value){
      if (value){
        this.$cookies.set('checkchkbox',true)
      }
    },
  },
  created () {
    this.handleView()
    window.addEventListener('resize', this.handleView)
    this.role = this.$cookies.get('role')
    if (
    (this.role === 'User' && this.$cookies.get('token')) ||
    this.role === 'Admin' && this.$cookies.get('token') ) {
      this.getmybill()
      this.$cookies.remove('chkboxWHT')
    }
    if (this.checkchkbox == 'true'){
      // console.log('checkchkbox == true');
      this.chkbox = true
    }else{
      this.dialogCondition = true;
    }

    if (this.mobileView){
      if (this.checkchkbox == 'true'){
      // console.log('checkchkbox == true');
      this.dialogCondition = false
      }
      else{
        this.dialogCondition = true
      }
    }
  }
}
</script>

<style scoped>
/* table.v-table thead th {
  font-size: 15px !important;
 }
table.v-table tbody td {
    font-size: 14px !important;
} */

table.v-table tbody td {
    font-size: 12px !important;
}
.summary{
    font-family: "Sarabun", sans-serif;
    font-size: 12px;
    font-style: normal;
    font-weight: 500;
    line-height: 16px;
    letter-spacing: 0em;
    color: #212121;
}
.item{
    font-family: "Sarabun", sans-serif;
    font-size: 12px;
    font-style: normal;
    font-weight: 500;
    line-height: 16px;
    letter-spacing: 0em;
    color: #AEAEAE;

}
.item1{
  font-size: 100%;
}

@media (max-width: 767.98px){
  .action-cell {
    display: inherit;
  }
  .table-headers{
    display: none
  }
  .custom-table-row{
    flex-direction:column;
    min-width:575.98px;
  }
  .mobile-coloumn-name{
    display: inline-block;
    min-width: 100px;
    font-weight:600;
  }
  .summary{
    font-size: 90%;
  }
  .item{
    font-size: 90%;
  }
  .item1{
    font-size: 90%;
  }
}

.btn-download-form {
  font-style: normal;
  font-weight: bold;
  font-size: 16px;
  line-height: 24px;
  text-align: center;
  color: #3a8300 !important;
  border-radius: 4px;
  float: right;
  margin: 16px 30px 16px 0px;
}

.text-search {
  font-style: normal;
  font-size: 16px;
  line-height: 24px;
  border-radius: 4px;
  color: #6a7d69;
  float: right;
  margin: 16px 30px 16px 0px;
}

.text-sub {
  font-style: normal;
  font-weight: 500;
  font-size: 16px;
  line-height: 24px;
  color: #757575;
  margin: 8px 0px;
}

.text-stepper-step {
  font-family: "Sarabun", sans-serif;
}

.btn-close {
  font-weight: bold;
  font-size: 16px;
  line-height: 24px;
  text-align: center;
  color: #d1392b !important;
  border-radius: 4px;
  text-transform: none;
  font-family: "Sarabun", sans-serif;
}

.title {
  font-weight: bold;
  font-size: 26px !important;
  font-family: "Sarabun", sans-serif !important;
}

.text-dialog {
  font-size: 18px;
  font-family: "Sarabun", sans-serif !important;
}

.text-head {
  font-weight: bold;
}

.btn-save {
  background-color: #58a144 !important;
  color: white;
  font-weight: bold;
  font-size: 16px;
  line-height: 24px;
  text-align: center;
  border-radius: 4px;
  text-transform: none;
}

.btn-create{
  background-color: #3A8300 !important;
  color: white;
  font-weight: bold;
  font-size: 16px;
  line-height: 24px;
  text-align: center;
  border-radius: 4px;
  text-transform: none;
  font-family: "Sarabun", sans-serif !important;
}

::v-deep .v-list__tile__title {
  color: black;
}
</style>
